<?php

	/*
		+---------------------------------------------------------------------+
		|                                                                     |
		|   SensorAndSwitch Update                              (sasupdate)   |
		|   ===============================================================   |
		|   Updateservice                                                     |
		|                                                                     |
		|   (C)2014/15 BlueDragon                                             !
		|                                                                     |
		+---------------------------------------------------------------------+
	*/

	define ("PRG","SensorAndSwitch Update");
	define ("VER","V 4.00.4000");
	define ("CPR","(C)2014 BlueDragon");

	error_reporting(0);
	
	$Config="sas.conf";
	$ConfigDat=$Config;
	$ConfigDir="conf/";
	mkdir($ConfigDir,0777);
	if (file_exists($ConfigDir) and file_exists($ConfigDat)) {
		if (copy($ConfigDat,$ConfigDir.$ConfigDat)) {
			unlink($ConfigDat);
		}
	}
	if (file_exists($ConfigDir.$ConfigDat)) {
		$Config=$ConfigDir.$ConfigDat;
	}
	
	$Cnf=array();
	$Conf=array();
	$Conf["PRG"]=PRG;
	$Conf["VER"]="0000000";
	$Conf["AKTVER"]="";
	$Conf["UPDATE"]="http://sas4pi.bluedragon.software/sas/info/sas.php";
	$Conf["UPDL"]="";
	$Conf["UPVER"]="";
	$Conf["PIC"]="images/";
	
	if (file_exists($Config)) {
		$AlleConfigWerte=file($Config);
		foreach ($AlleConfigWerte as $n => $ConfigWert) {
			$AlleConfigWerte[$n]=trim($AlleConfigWerte[$n]);
			$Cnf=explode("=",trim($ConfigWert));
			$Conf[trim(strtoupper($Cnf[0]))]=trim($Cnf[1]);
		}
	}

	$Conf["PRG"]=PRG;
	$Conf["AKTVER"]=$Conf["VER"];
	$Conf["VER"]=intval(str_replace(".","",substr(VER,2)));
	$Conf["UPDATE"]="http://sas4pi.bluedragon.software/sas/info/sas.php";
	
	define ("PRG",$Conf["PRG"]);
	define ("UPDATE",$Conf["UPDATE"]);
	define ("PIC",$Conf["PIC"]);

	date_default_timezone_set(ZEITZONE);
	
	$ch = curl_init();
	$timeout = 5;
	curl_setopt($ch, CURLOPT_URL, $Conf["UPDATE"]);
	curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.0)");
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER,false);
	curl_setopt($ch, CURLOPT_MAXREDIRS, 10);
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
	$Cont = curl_exec($ch);
	curl_close($ch);
	$Danach="SensorAndSwitch Version";
	$Conf["UPVER"]=intval(str_replace(".","",substr($Cont,strpos($Cont,$Danach)+24,12)));
	$Danach="SensorAndSwitch Download #";
	$Conf["UPDL"]=substr($Cont,strpos($Cont,$Danach)+26,100);
	$Danach="#";
	$Conf["UPDL"]=substr($Conf["UPDL"],0,strpos($Conf["UPDL"],$Danach));

	if (strlen($Conf["AKTVER"])<7) {
		$Conf["AKTVER"]=substr("0000000".$Conf["AKTVER"],-7);
	}
	if (strlen($Conf["UPVER"])<7) {
		$Conf["UPVER"]=substr("0000000".$Conf["UPVER"],-7);
	}
	$TextAktVer=substr($Conf["AKTVER"],-strlen($Conf["AKTVER"]),strlen($Conf["AKTVER"])-6).".".substr($Conf["AKTVER"],-6,2).".".substr($Conf["AKTVER"],-4,4);
	$TextUpVer=substr($Conf["UPVER"],-strlen($Conf["UPVER"]),strlen($Conf["UPVER"])-6).".".substr($Conf["UPVER"],-6,2).".".substr($Conf["UPVER"],-4,4);

	printf('<!DOCTYPE html><html><head>
			<meta charset="UTF-8">
			<meta http-equiv="X-UA-Compatible" content="IE=edge" />
			<title>'.PRG.'</title>
			<link rel="shortcut icon" href="'.PIC.'sas.ico">
			<style type="text/css">
				/* CSS Browser-Default-Werte löschen */
				html, body, div, span, applet, object, iframe, h1, h2, h3, h4, h5, h6, p, blockquote,pre, a, abbr, acronym, address, big, cite, code, del, dfn, em, font, img, ins, kbd, q, s, samp, small, strike, strong, sub, sup, tt, var, b, u, i, center, dl, dt, dd, ol, ul, li, fieldset, form, label, legend, table, caption, tbody, tfoot, thead, tr, th, td {
					margin:0;
					padding:0;
					border:0;
					outline:0;
					font-size:100%%;
					vertical-align:baseline;
					background:transparent;
				}
				body {
					line-height:1;
				}
				ol, ul {
					list-style:none;
				}
				blockquote, q {
					quotes:none;
				}
				blockquote:before, blockquote:after, q:before, q:after {
					content:"";
					content:none;
				}
				:focus {
					outline:0;
				}
				ins {
					text-decoration:none;
						}
				del {
					text-decoration:line-through;
				}
				table {
					border-collapse:collapse;
					border-spacing:0;
				}
				/* CSS zum Zentrieren */
				#seite {
					display:table;
					overflow:hidden;
					margin:0px auto;
				}
				*:first-child+html #seite {
					position:relative;
				}
				* html #seite {
					position:relative;
				}
				#container {
					display:table-cell;
					vertical-align: middle;
				}
				*:first-child+html #container {
					position:absolute;
					top:50%%;
				}
				* html #container {
					position:absolute;
					top:50%%;
				}
				*:first-child+html #inhalt {
					position:relative;
					top:-50%%;
				}
				* html #inhalt {
					position:relative;
					top:-50%%;
				}
				html, body {
					height:100%%;
				}
				/* CSS des Inhalts */
				body { 
					margin:0; 
					padding:0; 
					font-family:"Arial"; 
					color:#6091F9;
					background-color:#000000;
					font-size:20px; 
				}
				#seite {
					height:100%%;
					width:800px;
				}
				#container {
					padding:0px;
				}
				img {
					display:block;
				}
				div {
					border:0px; 
					border-style:solid;
					border-color:white;
				}
				#kopf { 
					text-align:center; 
					font-size:24px; 
					text-shadow:0px 0px 20px #6091F9,0px 0px 20px #6091F9,0px 0px 20px #6091F9;
				}
				#info { 
					text-align:center; 
					font-size:18px; 
					text-shadow:0px 0px 20px #6091F9,0px 0px 20px #6091F9,0px 0px 20px #6091F9;
				}
				#error { 
					text-align:center; 
					font-size:18px; 
					color:#FF7777;
					text-shadow:0px 0px 20px #FF0000,0px 0px 20px #FF0000,0px 0px 20px #FF0000;
				}
				#buttonok {
					font-family:"Arial"; 
					border-radius:10px;
					padding:5px;
					border-bottom:1px;
					border-style:solid;
					border-color:#006600;
					color:#00FF00;
					font-size:24px;
					text-align:center; 
					background-color:#004400;
					text-decoration:none;
					text-shadow:0px 0px 20px #00BB00,0px 0px 20px #00BB00,0px 0px 20px #00BB00;
				}
				#buttonok:hover {
					border-color:#00BB00;
					color:#CCFFCC;
				}
				#buttonok:active {
					border-color:#00FF00;
					color:#CCFFCC;
				}
			</style>
			</head><body>				
			<div id="seite"><div id="container"><div id="inhalt">');

	printf('<div id="kopf">'.PRG.' '.VER.' '.CPR.'</div>');
	printf('<div id="info">- - -</div>');
	
	if ($Conf["AKTVER"]<$Conf["UPVER"] or $_GET["update"]=="erzwingen") {
		printf('<div id="info">SensorAndSwitch wird von Version '.$TextAktVer.' auf Version '.$TextUpVer.' upgedatet...</div>');
		printf('<div id="info">Von: '.$Conf["UPDL"].'</div>');

		$zip = new ZipArchive;
		$Von=$Conf["UPDL"];
		$Neu="sasupdate.zip";
		$ch = curl_init();
		$timeout = 5;
		curl_setopt($ch, CURLOPT_URL, $Von);
		curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.0)");
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,false);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER,false);
		curl_setopt($ch, CURLOPT_MAXREDIRS, 10);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
		$daten = curl_exec($ch);
		curl_close($ch);
		file_put_contents($Neu,$daten);
		if ($zip->open($Neu) === TRUE) {
			$zip->extractTo('./');
			$zip->close();
			printf('<div id="info">Entpackt und Dateien upgedatet.</div>');
		} 
		else {
			printf('<div id="error">Fehler! Probleme mit der ZIP-Datei.</div>');
		}
		unlink($Neu);
	}
	else {
		printf('<div id="info">Aktuelle Version '.$TextAktVer.' neuer/gleich Downloadversion '.$TextUpVer.'.</div>');
		printf('<div id="error">Es wird kein Update durchgeführt!</div>');
	}
	printf('<div id="info">- - -</div>');
	printf('<div id="info"><form name="sasUpdate" method="POST" action=sas.php><input id="buttonok" type="submit" value="weiter" name="weiter"></form></div>');
	printf('</div></div></div></body></html>');
	
	exit;

?>